:- dynamic name_db/1.   /*Declare name_db as a predicate that has just one argument, as 
       a dynamic one*/

enter_name:- 
write('Enter name to be added correctly: '), 
add_name([]).
enter_name:- 
nl, write('Name could not be entered; Possible Error!').
discard_name:-
write('Enter name to be deleted correctly: '),
delete_name([]).
discard_name:-
nl, write('Name could not be discarded; the entry does not exist!').

add_name(TmpList):- 
getb(Char), Char =\=13,string_chars(Str,[Char]),
	write(Str),add_name([Char|TmpList]).
add_name(OutList):-
nl,reverse_list(OutList,[],List),
string_chars(String,List),
assert(name_db(String)),
write('Added '), write(String), write(' to database'), nl.

delete_name(TmpList):- 
getb(Char),Char =\=13,string_chars(Str,[Char]),
	write(Str),delete_name([Char|TmpList]).
delete_name(OutList):-
nl,reverse_list(OutList,[],List),
string_chars(String,List),
retract(name_db(String)),
write('Deleted '), write(String), write(' from database'), nl.

reverse_list([],OutList,OutList).
reverse_list([Head|Tail],TmpList,OutList):-
reverse_list(Tail,[Head|TmpList],OutList).
